﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XmlClassifier.DataStructures;
using XmlClassifier.DataStructures.Patterns;

namespace Scalability
{
	public class Program
	{
		public static void Main(string[] args)
		{
			List<Document> dataset = Read(@"..\Datasets\DS3.train.asc");
			List<Document> c0 = dataset.Where(x => x.ExpectedClass == 0).ToList();
			List<Document> c1 = dataset.Where(x => x.ExpectedClass == 1).ToList();

			List<Document> trainingSet = new List<Document>();

			Stopwatch sw = new Stopwatch();
			for (int i = 0; i < 100; i++)
			{
				for (int j = i * 500; j < (i + 1) * 500; j++)
				{
					trainingSet.Add(c0[j]);
					trainingSet.Add(c1[j]);
				}

				sw.Start();
				List<BasePattern> patterns = (new TreePattern()).GetPatterns(trainingSet, 0.007);
				TreePattern.RemoveDuplicatePatterns(patterns, TreePattern.Duplicates.RemoveEqual);
				sw.Stop();
				Console.WriteLine(sw.Elapsed);
				sw.Reset();
			}
		}

		private static List<Document> Read(string path)
		{
			List<Document> result = new List<Document>();

			using (StreamReader sr = new StreamReader(path))
			{
				while (!sr.EndOfStream)
				{
					result.Add(new Document(sr.ReadLine()));
				}
			}

			return result;
		}
	}
}
