﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using XmlClassifier.DataStructures;
using XmlClassifier.DataStructures.Patterns;
using XmlClassifier.Helpers;

namespace XmlClassifier.Algorithms.DistanceMeasures
{
	public class TED
	{
		public static int Process(XElement d1, XElement d2)
		{
			int[,] singleTable = new int[d1.Elements().Count() + 1, d2.Elements().Count() + 1];

			singleTable[0, 0] = 0;

			for (int j = 1; j < singleTable.GetLength(1); j++)
			{
				singleTable[0, j] = singleTable[0, j - 1] + d2.Elements().ElementAt(j - 1).DescendantNodesAndSelf().Count();
			}

			for (int i = 1; i < singleTable.GetLength(0); i++)
			{
				singleTable[i, 0] = singleTable[i - 1, 0] + d1.Elements().ElementAt(i - 1).DescendantNodesAndSelf().Count();
			}

			for (int i = 1; i < singleTable.GetLength(0); i++)
			{
				for (int j = 1; j < singleTable.GetLength(1); j++)
				{
					int top = singleTable[i - 1, j] + d1.Elements().ElementAt(i - 1).DescendantNodesAndSelf().Count();
					int left = singleTable[i, j - 1] + d2.Elements().ElementAt(j - 1).DescendantNodesAndSelf().Count();
					int both = singleTable[i - 1, j - 1] + Process(d1.Elements().ElementAt(i - 1), d2.Elements().ElementAt(j - 1));
					singleTable[i, j] = Math.Min(Math.Min(top, left), both);
				}
			}

			return singleTable[singleTable.GetLength(0) - 1, singleTable.GetLength(1) - 1] + (d1.Name.LocalName == d2.Name.LocalName ? 0 : 1);
		}
	}
}
