﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace XmlClassifier.DataStructures.Formats
{
	/// <summary>
	/// Klasa odpowiadzialna za transformację dokumentów XML w postaci drzew XElement do postaci nawiasowej, np. {a{b}{c{d}}}.
	/// </summary>
	public static class Bracets
	{
		/// <summary>
		/// Transformacja dokumentów XML z postaci drzew XElement do postaci nawiasowej, np. {a{b}{c{d}}}.
		/// </summary>
		/// <param name="tree">Drzewo do transformacji</param>
		/// <returns>Drzewo po transformacjiw postaci nawiasowej</returns>
		public static string Transform(XElement tree)
		{
			string result = string.Empty;
			Transform(tree, ref result);
			return result;
		}

		private static void Transform(XElement e, ref string result)
		{
			result += "{" + e.Name.LocalName;
			foreach (var child in e.Elements())
			{
				Transform(child, ref result);
			}
			result += "}";
		}
	}
}
